=== debian/changelog ===
vcmi (0.99+dfsg+git20190113.f06c8a87-2) unstable; urgency=medium

  * Add patch "Fix build with Boost version >= 1.70"
    Thanks Giovanni Mascellani (closes: #959417)

 -- Johannes 'josch' Schauer <josch@debian.org>  Wed, 03 Jun 2020 12:44:51 +0200

vcmi (0.99+dfsg+git20190113.f06c8a87-1) unstable; urgency=medium

  * Upstream did not make a release for more than two years. Since the current
    version in their git repository is superior to the last release in nearly
    every aspect, package that for inclusion in Debian Buster in accordance
    with upstream: https://bugs.vcmi.eu/view.php?id=3026
  * Drop all patches except the Debian-only patches that don't need
    upstreaming because all other issues were fixed upstream
  * Bump build dependency on libfuzzylite-dev to >= 6.0
  * Adjust d/rules for changed configure options and

 -- Johannes 'josch' Schauer <josch@debian.org>  Fri, 01 Feb 2019 22:13:16 +0100

vcmi (0.99+dfsg-6) unstable; urgency=medium

  * Add patch to support boost >= 1.66

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 18 Nov 2018 09:31:39 +0100
